//Listing 19.2 The Implementation of the Template Array
#include <iostream>

const int DefaultSize = 10;

// declare a simple Animal class so that we can
// create an array of animals

class Animal
{
  public:
    Animal(int);
    Animal();
    ~Animal() {}
    int GetWeight() const { return itsWeight; }
    void Display() const { std::cout << itsWeight; }
  private:
    int itsWeight;
};

Animal::Animal(int weight):
   itsWeight(weight)
{}

Animal::Animal():
   itsWeight(0)
{}


template <class T>  // declare the template and the parameter
class Array            // the class being parameterized
{
  public:
    // constructors
    Array(int itsSize = DefaultSize);
    Array(const Array &rhs);
    ~Array() { delete [] pType; }

    // operators
    Array& operator=(const Array&);
    T& operator[](int offSet) { return pType[offSet]; }
    const T& operator[](int offSet) const
      { return pType[offSet]; }
    // accessors
    int GetSize() const { return itsSize; }

  private:
    T *pType;
    int  itsSize;
};

// implementations follow...

// implement the Constructor
template <class T>
Array<T>::Array(int size):
itsSize(size)
{
   pType = new T[size];
   // the constructors of the type you are creating
   // should set a default value
}

// copy constructor
template <class T>
Array<T>::Array(const Array &rhs)
{
   itsSize = rhs.GetSize();
   pType = new T[itsSize];
   for (int i = 0; i<itsSize; i++)
      pType[i] = rhs[i];
}

// operator=
template <class T>
Array<T>& Array<T>::operator=(const Array &rhs)
{
   if (this == &rhs)
      return *this;
   delete [] pType;
   itsSize = rhs.GetSize();
   pType = new T[itsSize];
   for (int i = 0; i<itsSize; i++)
      pType[i] = rhs[i];
   return *this;
}

// driver program
int main()
{
   Array<int> theArray;      // an array of integers
   Array<Animal> theZoo;     // an array of Animals
   Animal *pAnimal;

   // fill the arrays
   for (int i = 0; i < theArray.GetSize(); i++)
   {
      theArray[i] = i*2;
      pAnimal = new Animal(i*3);
      theZoo[i] = *pAnimal;
      delete pAnimal;
   }
   // print the contents of the arrays
   for (int j = 0; j < theArray.GetSize(); j++)
   {
      std::cout << "theArray[" << j << "]:\t";
      std::cout << theArray[j] << "\t\t";
      std::cout << "theZoo[" << j << "]:\t";
      theZoo[j].Display();
      std::cout << std::endl;
   }

   return 0;
}
